import {createPageContext} from '@hooks';
import {Dispatch, useReducer, useState} from 'react';
import {createContext} from 'use-context-selector';

// #region 整体弹窗管理
type State = {
  name: string;
  onClose: null | (() => void);
  isSearching: boolean;
};

type Action =
| {type: 'SEARCH', payload: Pick<State, 'name'>}
| {type: 'RESET'}
| {type: 'SET_CLOSE', payload: State['onClose']}
| {type: 'CHANGE_SEARCH_STATE', payload: boolean};

function initState(onClose?: () => void): State {
  return {name: '', onClose: onClose ?? null, isSearching: false};
}

function reducer(state: State, action: Action): State {
  const {type} = action;

  switch (type) {
    case 'SEARCH':
      return {...state, ...action.payload};
    case 'SET_CLOSE':
      return {...state, onClose: action.payload};
    case 'CHANGE_SEARCH_STATE':
      return {...state, isSearching: action.payload};
    case 'RESET':
      return initState();
    default:
      return state;
  }
}

export function useContextReducer(onClose: () => void) {
  return useReducer(reducer, initState(onClose));
}

export const context = createContext<[State, Dispatch<Action>]>([initState(), () => null]);
// #endregion

/** 页码管理 */
export const pageContext = createPageContext();

// #region pId管理
export function usePIdContextState(init: string) {
  return useState(init);
}

export const pIdContext = createContext<ReturnType<typeof usePIdContextState>>(['', () => null]);
// #endregion
